###############################################################################
### SAML configuration

{%- set saml_flow_location = "@samlsp_flow_mapping_" + mapping["id"] %}
{%- set saml_error_location = "@saml_error_mapping_" + mapping["id"] %}

location ~ {{ src_path }}saml/(.*) {
  set $mapping_id {{ mapping["id"] }};
  set $saml_request_id "";
  set $saml_response_id "";

  ######### Shared memory zones that keep the SAML-related key-value databases

  # Zone for storing AuthnRequest and LogoutRequest message identifiers (ID)
  # to prevent replay attacks. (REQUIRED)
  # Timeout determines how long the SP waits for a response from the IDP,
  # i.e. how long the user authentication process can take.
  keyval_zone zone=saml_request_id:1M                 state=/var/lib/nginx/state/saml_request_id.json                  timeout=5m;

  # Zone for storing SAML Response message identifiers (ID) to prevent replay attacks. (REQUIRED)
  # Timeout determines how long the SP keeps IDs to prevent reuse.
  keyval_zone zone=saml_response_id:1M                state=/var/lib/nginx/state/saml_response_id.json                 timeout=1h;

  # Zone for storing SAML session access information. (REQUIRED)
  # Timeout determines how long the SP keeps session access decision (the session lifetime).
  keyval_zone zone=saml_session_access:1M             state=/var/lib/nginx/state/saml_session_access.json              timeout=1h;

  # Zone for storing SAML NameID values. (REQUIRED)
  # Timeout determines how long the SP keeps NameID values. Must be equal to session lifetime.
  keyval_zone zone=saml_name_id:1M                    state=/var/lib/nginx/state/saml_name_id.json                     timeout=1h;

  # Zone for storing SAML NameID format values. (REQUIRED)
  # Timeout determines how long the SP keeps NameID format values. Must be equal to session lifetime.
  keyval_zone zone=saml_name_id_format:1M             state=/var/lib/nginx/state/saml_name_id_format.json              timeout=1h;

  # Zone for storing SAML SessionIndex values. (REQUIRED)
  # Timeout determines how long the SP keeps SessionIndex values. Must be equal to session lifetime.
  keyval_zone zone=saml_session_index:1M              state=/var/lib/nginx/state/saml_session_index.json               timeout=1h;

  # Zone for storing SAML AuthnContextClassRef values. (REQUIRED)
  # Timeout determines how long the SP keeps AuthnContextClassRef values. Must be equal to session lifetime.
  keyval_zone zone=saml_authn_context_class_ref:1M    state=/var/lib/nginx/state/saml_authn_context_class_ref.json     timeout=1h;

  # Zones for storing SAML attributes values. (OPTIONAL)
  # Timeout determines how long the SP keeps attributes values. Must be equal to session lifetime.
  keyval_zone zone=saml_attrib_uid:1M                 state=/var/lib/nginx/state/saml_attrib_uid.json                  timeout=1h;
  keyval_zone zone=saml_attrib_name:1M                state=/var/lib/nginx/state/saml_attrib_name.json                 timeout=1h;
  keyval_zone zone=saml_attrib_memberOf:1M            state=/var/lib/nginx/state/saml_attrib_memberOf.json             timeout=1h;

  ######### SAML-related variables whose value is looked up by the key (session cookie) in the key-value database.

  # Required:
  keyval $saml_request_id     $saml_request_redeemed          zone=saml_request_id;               # SAML Request ID
  keyval $saml_response_id    $saml_response_redeemed         zone=saml_response_id;              # SAML Response ID
  keyval $cookie_auth_token   $saml_access_granted            zone=saml_session_access;           # SAML Access decision
  keyval $cookie_auth_token   $saml_name_id                   zone=saml_name_id;                  # SAML NameID
  keyval $cookie_auth_token   $saml_name_id_format            zone=saml_name_id_format;           # SAML NameIDFormat
  keyval $cookie_auth_token   $saml_session_index             zone=saml_session_index;            # SAML SessionIndex
  keyval $cookie_auth_token   $saml_authn_context_class_ref   zone=saml_authn_context_class_ref;  # SAML AuthnContextClassRef

  # Optional:
  keyval $cookie_auth_token   $saml_attrib_uid                zone=saml_attrib_uid;
  keyval $cookie_auth_token   $saml_attrib_name               zone=saml_attrib_name;
  keyval $cookie_auth_token   $saml_attrib_memberOf           zone=saml_attrib_memberOf;

  ######### Imports a module that implements SAML SSO and SLO functionality
  js_import samlsp from conf.d/saml_sp.js;

  set $internal_error_message "SAML Authentication failed. If problem persists, contact your system administrator.";
  js_var $internal_error_details;

  client_max_body_size    64k;
  client_body_buffer_size 64k;

  gunzip on;

  location ~ {{ src_path }}saml/acs {
    js_content samlsp.handleSingleSignOn;
    status_zone "SAMLSSO ACS";
    error_page 500 {{ saml_error_location }};
  }

  location ~ {{ src_path }}saml/sls {
    js_content samlsp.handleSingleLogout;
    status_zone "SAMLSSO SLS";
    error_page 500 {{ saml_error_location }};
  }

  location ~ {{ src_path }}saml/logout {
    js_content samlsp.initiateSingleLogout;
    status_zone "SAMLSSO logout";
    error_page 500 {{ saml_error_location }};
  }

  location ~ {{ src_path }}saml/_logout {
    default_type text/plain;
    return 200 "Logged out\n";
  }

  location {{ saml_flow_location }} {
    js_content samlsp.initiateSingleSignOn;
    set $cookie_auth_token "";
  }

  location {{ smal_error_location }} {
    status_zone "SAMLSP error";
    default_type text/plain;
    return 500 "$internal_error_message $internal_error_details";
  }
}
